/*
* vserver
* VPC Compute 관련 API<br/>https://ncloud.apigw.ntruss.com/vserver/v2
*
* NBP corp.
*
* NOTE: This class is auto generated by the swagger code generator program.
* https://github.com/swagger-api/swagger-codegen.git
* Do not edit the class manually.
*/

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Vserver) {
      root.Vserver = {};
    }
    root.Vserver.CreateNetworkInterfaceRequest = factory(root.Vserver.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The CreateNetworkInterfaceRequest model module.
   * @module model/CreateNetworkInterfaceRequest
   * @version 1.0.1
   */

  /**
   * Constructs a new <code>CreateNetworkInterfaceRequest</code>.
   * @alias module:model/CreateNetworkInterfaceRequest
   * @class
   * @param accessControlGroupNoList {Array.<String>} ACG번호리스트
   * @param subnetNo {String} 서브넷번호
   * @param vpcNo {String} VPC번호
   */
  var exports = function(accessControlGroupNoList, subnetNo, vpcNo) {
    var _this = this;


    _this['accessControlGroupNoList'] = accessControlGroupNoList;


    _this['subnetNo'] = subnetNo;
    _this['vpcNo'] = vpcNo;


  };

  /**
   * Constructs a <code>CreateNetworkInterfaceRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CreateNetworkInterfaceRequest} obj Optional instance to populate.
   * @return {module:model/CreateNetworkInterfaceRequest} The populated <code>CreateNetworkInterfaceRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('regionCode')) {
        obj['regionCode'] = ApiClient.convertToType(data['regionCode'], 'String');
      }
      if (data.hasOwnProperty('accessControlGroupNoList')) {
        obj['accessControlGroupNoList'] = ApiClient.convertToType(data['accessControlGroupNoList'], ['String']);
      }
      if (data.hasOwnProperty('networkInterfaceDescription')) {
        obj['networkInterfaceDescription'] = ApiClient.convertToType(data['networkInterfaceDescription'], 'String');
      }
      if (data.hasOwnProperty('networkInterfaceName')) {
        obj['networkInterfaceName'] = ApiClient.convertToType(data['networkInterfaceName'], 'String');
      }
      if (data.hasOwnProperty('subnetNo')) {
        obj['subnetNo'] = ApiClient.convertToType(data['subnetNo'], 'String');
      }
      if (data.hasOwnProperty('vpcNo')) {
        obj['vpcNo'] = ApiClient.convertToType(data['vpcNo'], 'String');
      }
      if (data.hasOwnProperty('serverInstanceNo')) {
        obj['serverInstanceNo'] = ApiClient.convertToType(data['serverInstanceNo'], 'String');
      }
      if (data.hasOwnProperty('ip')) {
        obj['ip'] = ApiClient.convertToType(data['ip'], 'String');
      }
    }
    return obj;
  }

  /**
   * REGION코드
   * @member {String} regionCode
   */
  exports.prototype['regionCode'] = undefined;
  /**
   * ACG번호리스트
   * @member {Array.<String>} accessControlGroupNoList
   */
  exports.prototype['accessControlGroupNoList'] = undefined;
  /**
   * 네트워크인터페이스설명
   * @member {String} networkInterfaceDescription
   */
  exports.prototype['networkInterfaceDescription'] = undefined;
  /**
   * 네트워크인터페이스이름
   * @member {String} networkInterfaceName
   */
  exports.prototype['networkInterfaceName'] = undefined;
  /**
   * 서브넷번호
   * @member {String} subnetNo
   */
  exports.prototype['subnetNo'] = undefined;
  /**
   * VPC번호
   * @member {String} vpcNo
   */
  exports.prototype['vpcNo'] = undefined;
  /**
   * 서버인스턴스번호
   * @member {String} serverInstanceNo
   */
  exports.prototype['serverInstanceNo'] = undefined;
  /**
   * IP주소
   * @member {String} ip
   */
  exports.prototype['ip'] = undefined;



  return exports;
}));


